// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{Ref, RefKind};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "FlatpakRemoteRef")]
    pub struct RemoteRef(Object<ffi::FlatpakRemoteRef, ffi::FlatpakRemoteRefClass>) @extends Ref;

    match fn {
        type_ => || ffi::flatpak_remote_ref_get_type(),
    }
}

impl RemoteRef {
    pub const NONE: Option<&'static RemoteRef> = None;

    // rustdoc-stripper-ignore-next
    /// Creates a new builder-pattern struct instance to construct [`RemoteRef`] objects.
    ///
    /// This method returns an instance of [`RemoteRefBuilder`](crate::builders::RemoteRefBuilder) which can be used to create [`RemoteRef`] objects.
    pub fn builder() -> RemoteRefBuilder {
        RemoteRefBuilder::new()
    }
}

// rustdoc-stripper-ignore-next
/// A [builder-pattern] type to construct [`RemoteRef`] objects.
///
/// [builder-pattern]: https://doc.rust-lang.org/1.0.0/style/ownership/builders.html
#[must_use = "The builder must be built to be used"]
pub struct RemoteRefBuilder {
    builder: glib::object::ObjectBuilder<'static, RemoteRef>,
}

impl RemoteRefBuilder {
    fn new() -> Self {
        Self {
            builder: glib::object::Object::builder(),
        }
    }

    pub fn download_size(self, download_size: u64) -> Self {
        Self {
            builder: self.builder.property("download-size", download_size),
        }
    }

    pub fn end_of_life(self, end_of_life: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("end-of-life", end_of_life.into()),
        }
    }

    pub fn end_of_life_rebase(self, end_of_life_rebase: impl Into<glib::GString>) -> Self {
        Self {
            builder: self
                .builder
                .property("end-of-life-rebase", end_of_life_rebase.into()),
        }
    }

    pub fn installed_size(self, installed_size: u64) -> Self {
        Self {
            builder: self.builder.property("installed-size", installed_size),
        }
    }

    pub fn metadata(self, metadata: &glib::Bytes) -> Self {
        Self {
            builder: self.builder.property("metadata", metadata.clone()),
        }
    }

    pub fn remote_name(self, remote_name: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("remote-name", remote_name.into()),
        }
    }

    pub fn arch(self, arch: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("arch", arch.into()),
        }
    }

    pub fn branch(self, branch: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("branch", branch.into()),
        }
    }

    pub fn collection_id(self, collection_id: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("collection-id", collection_id.into()),
        }
    }

    pub fn commit(self, commit: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("commit", commit.into()),
        }
    }

    pub fn kind(self, kind: RefKind) -> Self {
        Self {
            builder: self.builder.property("kind", kind),
        }
    }

    pub fn name(self, name: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("name", name.into()),
        }
    }

    // rustdoc-stripper-ignore-next
    /// Build the [`RemoteRef`].
    #[must_use = "Building the object from the builder is usually expensive and is not expected to have side effects"]
    pub fn build(self) -> RemoteRef {
        self.builder.build()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::RemoteRef>> Sealed for T {}
}

pub trait RemoteRefExt: IsA<RemoteRef> + sealed::Sealed + 'static {
    #[doc(alias = "flatpak_remote_ref_get_download_size")]
    #[doc(alias = "get_download_size")]
    fn download_size(&self) -> u64 {
        unsafe { ffi::flatpak_remote_ref_get_download_size(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "flatpak_remote_ref_get_eol")]
    #[doc(alias = "get_eol")]
    fn eol(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::flatpak_remote_ref_get_eol(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "flatpak_remote_ref_get_eol_rebase")]
    #[doc(alias = "get_eol_rebase")]
    fn eol_rebase(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::flatpak_remote_ref_get_eol_rebase(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "flatpak_remote_ref_get_installed_size")]
    #[doc(alias = "get_installed_size")]
    fn installed_size(&self) -> u64 {
        unsafe { ffi::flatpak_remote_ref_get_installed_size(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "flatpak_remote_ref_get_metadata")]
    #[doc(alias = "get_metadata")]
    fn metadata(&self) -> Option<glib::Bytes> {
        unsafe {
            from_glib_none(ffi::flatpak_remote_ref_get_metadata(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "flatpak_remote_ref_get_remote_name")]
    #[doc(alias = "get_remote_name")]
    fn remote_name(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::flatpak_remote_ref_get_remote_name(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "end-of-life")]
    fn end_of_life(&self) -> Option<glib::GString> {
        ObjectExt::property(self.as_ref(), "end-of-life")
    }

    #[doc(alias = "end-of-life-rebase")]
    fn end_of_life_rebase(&self) -> Option<glib::GString> {
        ObjectExt::property(self.as_ref(), "end-of-life-rebase")
    }
}

impl<O: IsA<RemoteRef>> RemoteRefExt for O {}
